#include "xbp.ch"
#include "Appevent.ch"
#include "GRA.ch"
#include "DLL.ch"

#include "PIMPIT.CH"
#define CRLF CHR(13)+CHR(10)

PROCEDURE appsys ; return
// ---------------------------------------------------------------------------

PROCEDURE Main()
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg
LOCAL oListBox
LOCAL oDa
LOCAL aSize
LOCAL i
LOCAL aPP := { { XBP_PP_COMPOUNDNAME, "24.Arial"                 },;
               { XBP_PP_BGCLR       , XBPSYSCLR_WINDOW           },;
               { XBP_PP_FGCLR       , XBPSYSCLR_WINDOWTEXT       },;
               { XBP_PP_HILITE_FGCLR, XBPSYSCLR_HILITEFOREGROUND },;
               { XBP_PP_HILITE_BGCLR, XBPSYSCLR_HILITEBACKGROUND } }

   SET DATE GERMAN
   SET CENTURY ON

   oDlg := XbpDialog():New(AppDesktop(),,{0,0}, {533,416},,.F.)
   oDlg:taskList := .T.
   oDlg:title    := "Drive XbpListBox"
   oDlg:close    := {|p1,p2,oo| PostAppEvent(xbeP_Quit,,,oo) }
   oDlg:resize   := {| aOldSize, aNewSize, oSelf | DlgResize(aOldSize, aNewSize, oSelf) }
   oDlg:Create()
   oDlg:drawingArea:ClipChildren := .T.

   CenterControl(oDlg)

   oDa   := oDlg:drawingArea
   aSize := oDa:Currentsize()

   oListBox := XbpListbox():new(oDa ,,{0,0},aSize,aPP)
   oListBox:create()
   // Auswahl
   oListBox:ItemSelected := {|mp1, mp2, oSelf| MsgBox( oSelf:GetItem(oSelf:getdata()[1]) )  }

   PimpMyXb(oListBox)

   oDlg:Show()
   SetAppFocus( oListBox )
   // Focus auf 1st Item
   oListBox:setdata({1})

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

   oDlg:destroy()

RETURN

PROCEDURE DlgResize(aOldSize, aNewSize, oSelf)
LOCAL oDraw   := oSelf:drawingArea
LOCAL aDraw   := oDraw:CurrentSize()
LOCAL aChild  := oDraw:Childlist()

   oDraw:LockUpdate(.T.)
   aChild[1]:setSize(aDraw)
   oDraw:LockUpdate(.F.)
   oDraw:invalidateRect()

RETURN

PROCEDURE PimpMyXb(oListBox)
LOCAL hWnd
LOCAL iAttr
LOCAL cMask

   //
   // get all Drive
   //
   hWnd  := oListBox:getHWND()
   iAttr := DDL_DRIVES
   cMask := "C:"
   SendMessageA( hWnd, LB_DIR, iAttr , cMask )

RETURN
*
* eof
*
